diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/DefinedTermDaoImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/DefinedTermDaoImpl.java
index f4e047905d..0614da765d 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/DefinedTermDaoImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/DefinedTermDaoImpl.java
@@ -15,7 +15,9 @@ import java.util.Enumeration;
 import java.util.List;
 import java.util.Locale;
 import java.util.Set;
+import java.util.UUID;
 
+import org.apache.commons.lang.StringUtils;
 import org.apache.log4j.Logger;
 import org.hibernate.Criteria;
 import org.hibernate.Query;
@@ -27,32 +29,26 @@ import org.hibernate.envers.query.AuditEntity;
 import org.hibernate.envers.query.AuditQuery;
 import org.springframework.stereotype.Repository;
 
-import eu.etaxonomy.cdm.model.agent.InstitutionType;
 import eu.etaxonomy.cdm.model.common.AnnotationType;
 import eu.etaxonomy.cdm.model.common.CdmBase;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.ExtensionType;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.common.MarkerType;
 import eu.etaxonomy.cdm.model.description.AbsenceTerm;
 import eu.etaxonomy.cdm.model.description.MeasurementUnit;
-import eu.etaxonomy.cdm.model.description.Modifier;
 import eu.etaxonomy.cdm.model.description.PresenceTerm;
-import eu.etaxonomy.cdm.model.description.Scope;
-import eu.etaxonomy.cdm.model.description.Sex;
-import eu.etaxonomy.cdm.model.description.Stage;
 import eu.etaxonomy.cdm.model.description.State;
 import eu.etaxonomy.cdm.model.description.StatisticalMeasure;
 import eu.etaxonomy.cdm.model.description.TextFormat;
-import eu.etaxonomy.cdm.model.location.Continent;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaLevel;
 import eu.etaxonomy.cdm.model.location.NamedAreaType;
 import eu.etaxonomy.cdm.model.location.ReferenceSystem;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.media.Media;
-import eu.etaxonomy.cdm.model.media.RightsTerm;
+import eu.etaxonomy.cdm.model.media.RightsType;
 import eu.etaxonomy.cdm.model.name.HybridRelationshipType;
 import eu.etaxonomy.cdm.model.name.NameRelationshipType;
 import eu.etaxonomy.cdm.model.name.NameTypeDesignationStatus;
@@ -60,7 +56,6 @@ import eu.etaxonomy.cdm.model.name.NomenclaturalStatusType;
 import eu.etaxonomy.cdm.model.name.Rank;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignationStatus;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEventType;
-import eu.etaxonomy.cdm.model.occurrence.DeterminationModifier;
 import eu.etaxonomy.cdm.model.occurrence.PreservationMethod;
 import eu.etaxonomy.cdm.model.taxon.SynonymRelationshipType;
 import eu.etaxonomy.cdm.model.taxon.TaxonRelationshipType;
@@ -80,41 +75,33 @@ public class DefinedTermDaoImpl extends IdentifiableDaoBase<DefinedTermBase> imp
 
 	public DefinedTermDaoImpl() {
 		super(DefinedTermBase.class);
-		indexedClasses = new Class[34];
-		indexedClasses[0] = InstitutionType.class;
+		indexedClasses = new Class[26];
+		indexedClasses[0] = Rank.class;
 		indexedClasses[1] = AnnotationType.class;
 		indexedClasses[2] = ExtensionType.class;
 		indexedClasses[3] = Language.class;
 		indexedClasses[4] = MarkerType.class;
 		indexedClasses[5] = AbsenceTerm.class;
 		indexedClasses[6] = MeasurementUnit.class;
-		indexedClasses[7] = Modifier.class;
+		indexedClasses[7] = DefinedTerm.class;
 		indexedClasses[8] = PresenceTerm.class;
-		indexedClasses[9] = Scope.class;
-		indexedClasses[10] = Sex.class;
-		indexedClasses[11] = Stage.class;
-		indexedClasses[12] = State.class;
-		indexedClasses[13] = StatisticalMeasure.class;
-		indexedClasses[14] = TextFormat.class;
-		indexedClasses[15] = Continent.class;
-		indexedClasses[16] = NamedArea.class;
-		indexedClasses[17] = NamedAreaLevel.class;
-		indexedClasses[18] = NamedAreaType.class;
-		indexedClasses[19] = ReferenceSystem.class;
-		indexedClasses[20] = TdwgArea.class;
-		indexedClasses[21] = WaterbodyOrCountry.class;
-		indexedClasses[22] = RightsTerm.class;
-		indexedClasses[23] = HybridRelationshipType.class;
-		indexedClasses[24] = NameRelationshipType.class;
-		indexedClasses[25] = NameTypeDesignationStatus.class;
-		indexedClasses[26] = NomenclaturalStatusType.class;
-		indexedClasses[27] = Rank.class;
-		indexedClasses[28] = SpecimenTypeDesignationStatus.class;
-		indexedClasses[29] = DerivationEventType.class;
-		indexedClasses[30] = DeterminationModifier.class;
-		indexedClasses[31] = PreservationMethod.class;
-		indexedClasses[32] = SynonymRelationshipType.class;
-		indexedClasses[33] = TaxonRelationshipType.class;
+		indexedClasses[9] = State.class;
+		indexedClasses[10] = StatisticalMeasure.class;
+		indexedClasses[11] = TextFormat.class;
+		indexedClasses[12] = DerivationEventType.class;
+		indexedClasses[13] = NamedArea.class;
+		indexedClasses[14] = NamedAreaLevel.class;
+		indexedClasses[15] = NamedAreaType.class;
+		indexedClasses[16] = ReferenceSystem.class;
+		indexedClasses[17] = Country.class;
+		indexedClasses[18] = RightsType.class;
+		indexedClasses[19] = HybridRelationshipType.class;
+		indexedClasses[20] = NameRelationshipType.class;
+		indexedClasses[21] = NameTypeDesignationStatus.class;
+		indexedClasses[22] = NomenclaturalStatusType.class;
+		indexedClasses[23] = SpecimenTypeDesignationStatus.class;
+		indexedClasses[24] = SynonymRelationshipType.class;
+		indexedClasses[25] = TaxonRelationshipType.class;
 	}
 
 	/**
@@ -144,9 +131,6 @@ public class DefinedTermDaoImpl extends IdentifiableDaoBase<DefinedTermBase> imp
 
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.persistence.dao.common.ITitledDao#findByTitleAndClass(java.lang.String, java.lang.Class)
-	 */
 	@Override
     public List<DefinedTermBase> findByTitleAndClass(String queryString, Class<DefinedTermBase> clazz) {
 		checkNotInPriorView("DefinedTermDaoImpl.findByTitleAndClass(String queryString, Class<DefinedTermBase> clazz)");
@@ -157,9 +141,6 @@ public class DefinedTermDaoImpl extends IdentifiableDaoBase<DefinedTermBase> imp
 		return results;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.persistence.dao.common.ITitledDao#findByTitle(java.lang.String, eu.etaxonomy.cdm.persistence.dao.common.ITitledDao.MATCH_MODE, int, int, java.util.List)
-	 */
 	@Override
     public List<DefinedTermBase> findByTitle(String queryString, MatchMode matchMode, int page, int pagesize, List<Criterion> criteria) {
 		//FIXME is query parametrised?
@@ -175,18 +156,18 @@ public class DefinedTermDaoImpl extends IdentifiableDaoBase<DefinedTermBase> imp
 
 
 	@Override
-    public WaterbodyOrCountry getCountryByIso(String iso639) {
+    public Country getCountryByIso(String iso3166) {
 		// If iso639 = "" query returns non-unique result. We prevent this here:
-		if (iso639.equals("") ) { return null; }
+		if (StringUtils.isBlank(iso3166)) { return null; }
 		AuditEvent auditEvent = getAuditEventFromContext();
 		if(auditEvent.equals(AuditEvent.CURRENT_VIEW)) {
-		  Query query = getSession().createQuery("from WaterbodyOrCountry where iso3166_A2 = :isoCode");
-		  query.setParameter("isoCode", iso639);
-		  return (WaterbodyOrCountry) query.uniqueResult();
+		  Query query = getSession().createQuery("from Country where iso3166_A2 = :isoCode");
+		  query.setParameter("isoCode", iso3166);
+		  return (Country) query.uniqueResult();
 		} else {
-			AuditQuery query = getAuditReader().createQuery().forEntitiesAtRevision(WaterbodyOrCountry.class,auditEvent.getRevisionNumber());
-			query.add(AuditEntity.property("iso3166_A2").eq(iso639));
-			return (WaterbodyOrCountry) query.getSingleResult();
+			AuditQuery query = getAuditReader().createQuery().forEntitiesAtRevision(Country.class,auditEvent.getRevisionNumber());
+			query.add(AuditEntity.property("iso3166_A2").eq(iso3166));
+			return (Country) query.getSingleResult();
 		}
 	}
 
@@ -235,6 +216,31 @@ public class DefinedTermDaoImpl extends IdentifiableDaoBase<DefinedTermBase> imp
         return ((Number)criteria.uniqueResult()).intValue();
 	}
 
+	@Override
+	public <T extends DefinedTermBase> List<T> getDefinedTermByIdInVocabulary(String label, UUID vocUuid, Class<T> clazz, Integer pageSize, Integer pageNumber) {
+		checkNotInPriorView("DefinedTermDaoImpl.getDefinedTermByIdInVocabulary(String label, UUID vocUuid, Class<T> clazz, Integer pageSize, Integer pageNumber)");
+
+		Criteria criteria = null;
+		if(clazz == null) {
+			criteria = getSession().createCriteria(type);
+		} else {
+			criteria = getSession().createCriteria(clazz);
+		}
+
+		criteria.createAlias("vocabulary", "voc").add(Restrictions.like("voc.uuid", vocUuid))
+			.add(Restrictions.like("idInVocabulary", label, org.hibernate.criterion.MatchMode.EXACT));
+
+		if(pageSize != null) {
+			criteria.setMaxResults(pageSize);
+		    if(pageNumber != null) {
+		    	criteria.setFirstResult(pageNumber * pageSize);
+		    }
+		}
+
+		List<T> result = criteria.list();
+		return result;
+	}
+
 	@Override
 	public <T extends DefinedTermBase> List<T> getDefinedTermByRepresentationAbbrev(String text, Class<T> clazz, Integer pageSize,Integer  pageNumber) {
 		checkNotInPriorView("DefinedTermDaoImpl.getDefinedTermByRepresentationAbbrev(String abbrev, Class<T> clazz, Integer pageSize,Integer  pageNumber)");
@@ -276,25 +282,37 @@ public class DefinedTermDaoImpl extends IdentifiableDaoBase<DefinedTermBase> imp
         return ((Number)criteria.uniqueResult()).intValue();
 	}
 
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.persistence.dao.common.IDefinedTermDao#getLangaugeByIso(java.lang.String)
-	 */
 	@Override
     public Language getLanguageByIso(String iso639) {
 		if (iso639.length() < 2 || iso639.length() > 3) {
 			logger.warn("Invalid length " + iso639.length() + " of ISO code. Length must be 2 or 3.");
 			return null;
 		}
-		String isoStandart = "iso639_" + (iso639.length() - 1);
+		boolean isIso639_1 = iso639.length() == 2;
+		
+		String queryStr;
+		if (isIso639_1){
+			queryStr = "from Language where iso639_1 = :isoCode";
+		}else{
+			queryStr = "from Language where idInVocabulary = :isoCode and vocabulary.uuid = :vocUuid";
+		}
 		AuditEvent auditEvent = getAuditEventFromContext();
 		if(auditEvent.equals(AuditEvent.CURRENT_VIEW)) {
-		    Query query = getSession().createQuery("from Language where " + isoStandart + "= :isoCode");
+		    Query query = getSession().createQuery(queryStr);
 		    query.setParameter("isoCode", iso639);
+		    if (! isIso639_1){
+		    	query.setParameter("vocUuid", Language.uuidLanguageVocabulary);
+			}
 		    return (Language) query.uniqueResult();
 		} else {
 			AuditQuery query = getAuditReader().createQuery().forEntitiesAtRevision(Language.class,auditEvent.getRevisionNumber());
-			query.add(AuditEntity.property(isoStandart).eq(iso639));
+			if (isIso639_1){
+				query.add(AuditEntity.property("iso639_1").eq(iso639));
+			}else{
+				query.add(AuditEntity.property("iso639_2").eq(iso639));
+				query.add(AuditEntity.property("vocabulary.uuid").eq(Language.uuidLanguageVocabulary));
+			}
+			
 			return (Language)query.getSingleResult();
 		}
 	}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/IdentifiableDaoBase.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/IdentifiableDaoBase.java
index 1bf4fea28e..cf1612fc51 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/IdentifiableDaoBase.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/IdentifiableDaoBase.java
@@ -10,7 +10,6 @@
 package eu.etaxonomy.cdm.persistence.dao.hibernate.common;
 
 import java.util.ArrayList;
-import java.util.Arrays;
 import java.util.List;
 import java.util.UUID;
 
@@ -18,7 +17,6 @@ import org.apache.log4j.Logger;
 import org.apache.lucene.analysis.standard.StandardAnalyzer;
 import org.apache.lucene.queryParser.ParseException;
 import org.apache.lucene.queryParser.QueryParser;
-import org.apache.lucene.util.Version;
 import org.hibernate.Criteria;
 import org.hibernate.Query;
 import org.hibernate.Session;
@@ -42,10 +40,8 @@ import eu.etaxonomy.cdm.model.common.UuidAndTitleCache;
 import eu.etaxonomy.cdm.model.media.Rights;
 import eu.etaxonomy.cdm.persistence.dao.QueryParseException;
 import eu.etaxonomy.cdm.persistence.dao.common.IIdentifiableDao;
-import eu.etaxonomy.cdm.persistence.dao.hibernate.AlternativeSpellingSuggestionParser;
 import eu.etaxonomy.cdm.persistence.query.MatchMode;
 import eu.etaxonomy.cdm.persistence.query.OrderHint;
-import eu.etaxonomy.cdm.persistence.query.OrderHint.SortOrder;
 
 
 public class IdentifiableDaoBase<T extends IdentifiableEntity> extends AnnotatableDaoImpl<T> implements IIdentifiableDao<T>{
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/PreferenceDaoImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/PreferenceDaoImpl.java
new file mode 100644
index 0000000000..b8f84e978f
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/PreferenceDaoImpl.java
@@ -0,0 +1,64 @@
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/ 
+
+package eu.etaxonomy.cdm.persistence.dao.hibernate.common;
+
+import org.hibernate.Criteria;
+import org.hibernate.Session;
+import org.hibernate.criterion.Projections;
+import org.springframework.stereotype.Repository;
+
+import eu.etaxonomy.cdm.model.metadata.CdmPreference;
+import eu.etaxonomy.cdm.persistence.dao.common.IPreferenceDao;
+
+/**
+ * @author a.mueller
+ * @created 2013-09-09
+ */
+@Repository
+public class PreferenceDaoImpl extends DaoBase implements IPreferenceDao  {
+	
+	@Override
+	public CdmPreference get(CdmPreference.PrefKey key){
+		Session session = getSession();
+		return (CdmPreference)session.get(CdmPreference.class, key);
+
+		//old
+//		StatelessSession session = getSessionFactory().openStatelessSession();
+//		return (CdmPreference) session.get(CdmPreference.class, key);
+
+	}
+	
+	@Override
+	public void set(CdmPreference preference){
+		CdmPreference pref = get(preference.getKey());
+		//maybe 
+		//TODO maybe there is better way to allow updates without allowing to write CdmPref.value
+		if (pref != null){
+			getSession().delete(pref);
+		}
+		getSession().save(preference);
+		
+		//old
+//		if (pref == null){
+//			getSessionFactory().openStatelessSession().insert(preference);
+//		}else{
+//			getSessionFactory().openStatelessSession().update(preference);
+//		}
+	}
+	
+	@Override
+	public int count(){
+		Criteria crit = getSession().createCriteria(CdmPreference.class);
+        crit.setProjection(Projections.rowCount());
+        int result = ((Number)crit.list().get(0)).intValue();
+        return result;
+	}
+	
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/TermVocabularyDaoImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/TermVocabularyDaoImpl.java
index a29e9048eb..39fe2859e1 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/TermVocabularyDaoImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/TermVocabularyDaoImpl.java
@@ -22,6 +22,7 @@ import org.springframework.stereotype.Repository;
 
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.OrderedTermVocabulary;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.view.AuditEvent;
 import eu.etaxonomy.cdm.persistence.dao.common.ITermVocabularyDao;
@@ -108,6 +109,27 @@ public class TermVocabularyDaoImpl extends IdentifiableDaoBase<TermVocabulary> i
 		}
 	}
 
+//	public <T extends DefinedTermBase> List<TermVocabulary<T>> findByTermType(TermType termType) {
+//
+//		Query query = getSession().createQuery("select vocabulary from TermVocabulary vocabulary where vocabulary.termType= :termType");
+//		query.setParameter("termType", termType);
+//
+//		return (List<TermVocabulary<T>>)query.list();
+//
+//	}
+	
+	public <T extends DefinedTermBase> List<TermVocabulary<T>> findByTermType(TermType termType) {
+		
+		Criteria criteria = getSession().createCriteria(type);
+		criteria.add(Restrictions.eq("termType", termType));		
+				
+		//this.addOrder(criteria, orderHints);
+		
+		List<TermVocabulary<T>> result = (List<TermVocabulary<T>>)criteria.list();
+	    defaultBeanInitializer.initializeAll(result, null);
+		return result;
+	}
+
 	public <T extends DefinedTermBase> List<T> getTerms(TermVocabulary<T> termVocabulary, Integer pageSize,	Integer pageNumber) {
 		return getTerms(termVocabulary, pageSize, pageNumber, null, null);
 	}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/description/DescriptionDaoImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/description/DescriptionDaoImpl.java
index 5cab5f5117..182be772d9 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/description/DescriptionDaoImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/description/DescriptionDaoImpl.java
@@ -26,6 +26,7 @@ import org.hibernate.envers.query.AuditQuery;
 import org.springframework.beans.factory.annotation.Qualifier;
 import org.springframework.stereotype.Repository;
 
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.LSID;
 import eu.etaxonomy.cdm.model.common.MarkerType;
 import eu.etaxonomy.cdm.model.description.CommonTaxonName;
@@ -33,7 +34,6 @@ import eu.etaxonomy.cdm.model.description.DescriptionBase;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
-import eu.etaxonomy.cdm.model.description.Scope;
 import eu.etaxonomy.cdm.model.description.SpecimenDescription;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
@@ -195,7 +195,7 @@ public class DescriptionDaoImpl extends IdentifiableDaoBase<DescriptionBase> imp
     }
 
     @Override
-    public int countTaxonDescriptions(Taxon taxon, Set<Scope> scopes,Set<NamedArea> geographicalScopes, Set<MarkerType> markerTypes) {
+    public int countTaxonDescriptions(Taxon taxon, Set<DefinedTerm> scopes,Set<NamedArea> geographicalScopes, Set<MarkerType> markerTypes) {
         AuditEvent auditEvent = getAuditEventFromContext();
         if(auditEvent.equals(AuditEvent.CURRENT_VIEW)) {
             Criteria criteria = getSession().createCriteria(TaxonDescription.class);
@@ -206,7 +206,7 @@ public class DescriptionDaoImpl extends IdentifiableDaoBase<DescriptionBase> imp
 
             if(scopes != null && !scopes.isEmpty()) {
                 Set<Integer> scopeIds = new HashSet<Integer>();
-                for(Scope s : scopes) {
+                for(DefinedTerm s : scopes) {
                     scopeIds.add(s.getId());
                 }
                 criteria.createCriteria("scopes").add(Restrictions.in("id", scopeIds));
@@ -358,7 +358,7 @@ public class DescriptionDaoImpl extends IdentifiableDaoBase<DescriptionBase> imp
     }
 
     @Override
-    public List<TaxonDescription> listTaxonDescriptions(Taxon taxon, Set<Scope> scopes, Set<NamedArea> geographicalScopes, Set<MarkerType> markerTypes, Integer pageSize, Integer pageNumber, List<String> propertyPaths) {
+    public List<TaxonDescription> listTaxonDescriptions(Taxon taxon, Set<DefinedTerm> scopes, Set<NamedArea> geographicalScopes, Set<MarkerType> markerTypes, Integer pageSize, Integer pageNumber, List<String> propertyPaths) {
         AuditEvent auditEvent = getAuditEventFromContext();
         if(auditEvent.equals(AuditEvent.CURRENT_VIEW)) {
             Criteria criteria = getSession().createCriteria(TaxonDescription.class);
@@ -369,7 +369,7 @@ public class DescriptionDaoImpl extends IdentifiableDaoBase<DescriptionBase> imp
 
             if(scopes != null && !scopes.isEmpty()) {
                 Set<Integer> scopeIds = new HashSet<Integer>();
-                for(Scope s : scopes) {
+                for(DefinedTerm s : scopes) {
                     scopeIds.add(s.getId());
                 }
                 criteria.createCriteria("scopes").add(Restrictions.in("id", scopeIds));
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/description/FeatureTreeDaoImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/description/FeatureTreeDaoImpl.java
index 2218ecade8..e96ca6d4b0 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/description/FeatureTreeDaoImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/description/FeatureTreeDaoImpl.java
@@ -53,7 +53,7 @@ public class FeatureTreeDaoImpl extends IdentifiableDaoBase<FeatureTree> impleme
 	}
 
 	public void loadNodes(FeatureNode root, List<String> nodePaths) {
-		for(FeatureNode child : root.getChildren()) {
+		for(FeatureNode child : root.getChildNodes()) {
 			defaultBeanInitializer.initialize(child, nodePaths);
 			loadNodes(child,nodePaths);
 		}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/occurrence/OccurrenceDaoHibernateImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/occurrence/OccurrenceDaoHibernateImpl.java
index f4d5c996f0..8d4d8b499b 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/occurrence/OccurrenceDaoHibernateImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/occurrence/OccurrenceDaoHibernateImpl.java
@@ -32,16 +32,10 @@ import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.molecular.DnaSample;
 import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignation;
-import eu.etaxonomy.cdm.model.name.TypeDesignationBase;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEvent;
 import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
 import eu.etaxonomy.cdm.model.occurrence.DeterminationEvent;
-import eu.etaxonomy.cdm.model.occurrence.FieldObservation;
-import eu.etaxonomy.cdm.model.occurrence.Fossil;
-import eu.etaxonomy.cdm.model.occurrence.LivingBeing;
-import eu.etaxonomy.cdm.model.occurrence.Observation;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
+import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
@@ -76,13 +70,9 @@ public class OccurrenceDaoHibernateImpl extends IdentifiableDaoBase<SpecimenOrOb
 	public OccurrenceDaoHibernateImpl() {
 		super(SpecimenOrObservationBase.class);
 		indexedClasses = new Class[7];
-		indexedClasses[0] = FieldObservation.class;
+		indexedClasses[0] = FieldUnit.class;
 		indexedClasses[1] = DerivedUnit.class;
-		indexedClasses[2] = LivingBeing.class;
-		indexedClasses[3] = Observation.class;
-		indexedClasses[4] = Specimen.class;
 		indexedClasses[5] = DnaSample.class;
-		indexedClasses[6] = Fossil.class;
 	}
 
 	/* (non-Javadoc)
@@ -253,8 +243,8 @@ public class OccurrenceDaoHibernateImpl extends IdentifiableDaoBase<SpecimenOrOb
 			    Hibernate.initialize(determination.getTaxon());
 			}
 			Hibernate.initialize(occurrence.getDefinition());
-			if(occurrence instanceof DerivedUnitBase) {
-				DerivedUnitBase derivedUnit = (DerivedUnitBase) occurrence;
+			if(occurrence instanceof DerivedUnit) {
+				DerivedUnit derivedUnit = (DerivedUnit) occurrence;
 				Hibernate.initialize(derivedUnit.getCollection());
 				if(derivedUnit.getCollection() != null) {
 					Hibernate.initialize(derivedUnit.getCollection().getSuperCollection());
@@ -262,11 +252,11 @@ public class OccurrenceDaoHibernateImpl extends IdentifiableDaoBase<SpecimenOrOb
 				}
 				Hibernate.initialize(derivedUnit.getStoredUnder());
 				SpecimenOrObservationBase original = derivedUnit.getOriginalUnit();
-				if(original != null && original.isInstanceOf(FieldObservation.class)) {
-					FieldObservation fieldObservation = original.deproxy(original, FieldObservation.class);
-					Hibernate.initialize(fieldObservation.getGatheringEvent());
-					if(fieldObservation.getGatheringEvent() != null) {
-						Hibernate.initialize(fieldObservation.getGatheringEvent().getActor());
+				if(original != null && original.isInstanceOf(FieldUnit.class)) {
+					FieldUnit fieldUnit = original.deproxy(original, FieldUnit.class);
+					Hibernate.initialize(fieldUnit.getGatheringEvent());
+					if(fieldUnit.getGatheringEvent() != null) {
+						Hibernate.initialize(fieldUnit.getGatheringEvent().getActor());
 					}
 				}
 			}
@@ -324,38 +314,38 @@ public class OccurrenceDaoHibernateImpl extends IdentifiableDaoBase<SpecimenOrOb
 	}
 
 	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.persistence.dao.occurrence.IOccurrenceDao#getDerivedUnitBaseUuidAndTitleCache()
+	 * @see eu.etaxonomy.cdm.persistence.dao.occurrence.IOccurrenceDao#getDerivedUnitUuidAndTitleCache()
 	 */
 	@Override
-	public List<UuidAndTitleCache<DerivedUnitBase>> getDerivedUnitBaseUuidAndTitleCache() {
-		List<UuidAndTitleCache<DerivedUnitBase>> list = new ArrayList<UuidAndTitleCache<DerivedUnitBase>>();
+	public List<UuidAndTitleCache<DerivedUnit>> getDerivedUnitUuidAndTitleCache() {
+		List<UuidAndTitleCache<DerivedUnit>> list = new ArrayList<UuidAndTitleCache<DerivedUnit>>();
 		Session session = getSession();
 		
-		Query query = session.createQuery("select uuid, titleCache from " + type.getSimpleName() + " where NOT dtype = " + FieldObservation.class.getSimpleName());
+		Query query = session.createQuery("select uuid, titleCache from " + type.getSimpleName() + " where NOT dtype = " + FieldUnit.class.getSimpleName());
 		
 		List<Object[]> result = query.list();
 		
 		for(Object[] object : result){
-			list.add(new UuidAndTitleCache<DerivedUnitBase>(DerivedUnitBase.class, (UUID) object[0], (String) object[1]));
+			list.add(new UuidAndTitleCache<DerivedUnit>(DerivedUnit.class, (UUID) object[0], (String) object[1]));
 		}
 		
 		return list;
 	}
 
 	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.persistence.dao.occurrence.IOccurrenceDao#getFieldObservationUuidAndTitleCache()
+	 * @see eu.etaxonomy.cdm.persistence.dao.occurrence.IOccurrenceDao#getFieldUnitUuidAndTitleCache()
 	 */
 	@Override
-	public List<UuidAndTitleCache<FieldObservation>> getFieldObservationUuidAndTitleCache() {
-		List<UuidAndTitleCache<FieldObservation>> list = new ArrayList<UuidAndTitleCache<FieldObservation>>();
+	public List<UuidAndTitleCache<FieldUnit>> getFieldUnitUuidAndTitleCache() {
+		List<UuidAndTitleCache<FieldUnit>> list = new ArrayList<UuidAndTitleCache<FieldUnit>>();
 		Session session = getSession();
 		
-		Query query = session.createQuery("select uuid, titleCache from " + type.getSimpleName() + " where dtype = " + FieldObservation.class.getSimpleName());
+		Query query = session.createQuery("select uuid, titleCache from " + type.getSimpleName() + " where dtype = " + FieldUnit.class.getSimpleName());
 		
 		List<Object[]> result = query.list();
 		
 		for(Object[] object : result){
-			list.add(new UuidAndTitleCache<FieldObservation>(FieldObservation.class, (UUID) object[0], (String) object[1]));
+			list.add(new UuidAndTitleCache<FieldUnit>(FieldUnit.class, (UUID) object[0], (String) object[1]));
 		}
 		
 		return list;
@@ -374,7 +364,7 @@ public class OccurrenceDaoHibernateImpl extends IdentifiableDaoBase<SpecimenOrOb
 		List<SpecimenOrObservationBase> byDetermination = list(type, associatedTaxon, null, 0, null, null);
 		setOfAll.addAll(byDetermination);
 		
-		// The IndividualsAssociation elements in a TaxonDescription contain DerivedUnitBases 
+		// The IndividualsAssociation elements in a TaxonDescription contain DerivedUnits 
 		List<IndividualsAssociation> byIndividualsAssociation = descriptionDao.getDescriptionElementForTaxon(
 				associatedTaxon, null, IndividualsAssociation.class, null, 0, null);
 		for(IndividualsAssociation individualsAssociation : byIndividualsAssociation){
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/reference/ReferenceDaoHibernateImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/reference/ReferenceDaoHibernateImpl.java
index df4035e948..9c35e21bdb 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/reference/ReferenceDaoHibernateImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/reference/ReferenceDaoHibernateImpl.java
@@ -36,7 +36,7 @@ import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.cdm.persistence.dao.hibernate.common.IdentifiableDaoBase;
 import eu.etaxonomy.cdm.persistence.dao.reference.IReferenceDao;
 import eu.etaxonomy.cdm.persistence.query.OrderHint;
-import eu.etaxonomy.cdm.strategy.cache.reference.ReferenceBaseDefaultCacheStrategy;
+import eu.etaxonomy.cdm.strategy.cache.reference.ReferenceDefaultCacheStrategy;
 
 /**
  * @author a.mueller
@@ -108,7 +108,7 @@ public class ReferenceDaoHibernateImpl extends IdentifiableDaoBase<Reference> im
 
 			if(referenceTitle != null){
 				String teamTitle = (String) object[2];
-				referenceTitle = ReferenceBaseDefaultCacheStrategy.putAuthorToEndOfString(referenceTitle, teamTitle);
+				referenceTitle = ReferenceDefaultCacheStrategy.putAuthorToEndOfString(referenceTitle, teamTitle);
 
 				list.add(new UuidAndTitleCache<Reference>(Reference.class, (UUID) object[0], referenceTitle));
 			}else{
